# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from pr2_gripper_sensor_msgs/PR2GripperFindContactFeedback.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import genpy
import pr2_gripper_sensor_msgs.msg

class PR2GripperFindContactFeedback(genpy.Message):
  _md5sum = "a1cc8c2fc9268b550e6167f268f97574"
  _type = "pr2_gripper_sensor_msgs/PR2GripperFindContactFeedback"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======
# feedback
PR2GripperFindContactData data



================================================================================
MSG: pr2_gripper_sensor_msgs/PR2GripperFindContactData
# Time the data was recorded at
time stamp

# true when our contact conditions have been met
# (see PR2GripperFindContact command)
bool contact_conditions_met

# the finger contact conditions 
# true if the finger experienced a contact event
#
# contact events are defined as contact with the fingerpads
# as either steady-state or high-freq force events
bool left_fingertip_pad_contact
bool right_fingertip_pad_contact

# the force experinced by the finger Pads  (N)
# NOTE:this ignores data from the edges of the finger pressure
float64 left_fingertip_pad_force
float64 right_fingertip_pad_force

# the current joint position (m)
float64 joint_position

# the virtual (parallel) joint effort (N)
float64 joint_effort

# the control state of our realtime controller
PR2GripperSensorRTState rtstate
================================================================================
MSG: pr2_gripper_sensor_msgs/PR2GripperSensorRTState
# the control state of our realtime controller
int8 realtime_controller_state

# predefined values to indicate our realtime_controller_state
int8 DISABLED = 0
int8 POSITION_SERVO = 3
int8 FORCE_SERVO = 4
int8 FIND_CONTACT = 5
int8 SLIP_SERVO = 6"""
  __slots__ = ['data']
  _slot_types = ['pr2_gripper_sensor_msgs/PR2GripperFindContactData']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       data

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(PR2GripperFindContactFeedback, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.data is None:
        self.data = pr2_gripper_sensor_msgs.msg.PR2GripperFindContactData()
    else:
      self.data = pr2_gripper_sensor_msgs.msg.PR2GripperFindContactData()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_2I3B4db().pack(_x.data.stamp.secs, _x.data.stamp.nsecs, _x.data.contact_conditions_met, _x.data.left_fingertip_pad_contact, _x.data.right_fingertip_pad_contact, _x.data.left_fingertip_pad_force, _x.data.right_fingertip_pad_force, _x.data.joint_position, _x.data.joint_effort, _x.data.rtstate.realtime_controller_state))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.data is None:
        self.data = pr2_gripper_sensor_msgs.msg.PR2GripperFindContactData()
      end = 0
      _x = self
      start = end
      end += 44
      (_x.data.stamp.secs, _x.data.stamp.nsecs, _x.data.contact_conditions_met, _x.data.left_fingertip_pad_contact, _x.data.right_fingertip_pad_contact, _x.data.left_fingertip_pad_force, _x.data.right_fingertip_pad_force, _x.data.joint_position, _x.data.joint_effort, _x.data.rtstate.realtime_controller_state,) = _get_struct_2I3B4db().unpack(str[start:end])
      self.data.contact_conditions_met = bool(self.data.contact_conditions_met)
      self.data.left_fingertip_pad_contact = bool(self.data.left_fingertip_pad_contact)
      self.data.right_fingertip_pad_contact = bool(self.data.right_fingertip_pad_contact)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_2I3B4db().pack(_x.data.stamp.secs, _x.data.stamp.nsecs, _x.data.contact_conditions_met, _x.data.left_fingertip_pad_contact, _x.data.right_fingertip_pad_contact, _x.data.left_fingertip_pad_force, _x.data.right_fingertip_pad_force, _x.data.joint_position, _x.data.joint_effort, _x.data.rtstate.realtime_controller_state))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.data is None:
        self.data = pr2_gripper_sensor_msgs.msg.PR2GripperFindContactData()
      end = 0
      _x = self
      start = end
      end += 44
      (_x.data.stamp.secs, _x.data.stamp.nsecs, _x.data.contact_conditions_met, _x.data.left_fingertip_pad_contact, _x.data.right_fingertip_pad_contact, _x.data.left_fingertip_pad_force, _x.data.right_fingertip_pad_force, _x.data.joint_position, _x.data.joint_effort, _x.data.rtstate.realtime_controller_state,) = _get_struct_2I3B4db().unpack(str[start:end])
      self.data.contact_conditions_met = bool(self.data.contact_conditions_met)
      self.data.left_fingertip_pad_contact = bool(self.data.left_fingertip_pad_contact)
      self.data.right_fingertip_pad_contact = bool(self.data.right_fingertip_pad_contact)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_2I3B4db = None
def _get_struct_2I3B4db():
    global _struct_2I3B4db
    if _struct_2I3B4db is None:
        _struct_2I3B4db = struct.Struct("<2I3B4db")
    return _struct_2I3B4db
