# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from pr2_gripper_sensor_msgs/PR2GripperForceServoFeedback.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import genpy
import pr2_gripper_sensor_msgs.msg

class PR2GripperForceServoFeedback(genpy.Message):
  _md5sum = "a85c0d43537b45945527f5de565ab7c2"
  _type = "pr2_gripper_sensor_msgs/PR2GripperForceServoFeedback"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======

#feedback
PR2GripperForceServoData data

================================================================================
MSG: pr2_gripper_sensor_msgs/PR2GripperForceServoData
# Time the data was recorded at
time stamp

# the force experienced by the finger Pads  (N)
# NOTE:this ignores data from the edges of the finger pressure
float64 left_fingertip_pad_force
float64 right_fingertip_pad_force

# the current gripper virtual parallel joint effort (in N)
float64 joint_effort

# true when the gripper is no longer moving
# and we have reached the desired force level
bool force_achieved


# the control state of our realtime controller
PR2GripperSensorRTState rtstate

================================================================================
MSG: pr2_gripper_sensor_msgs/PR2GripperSensorRTState
# the control state of our realtime controller
int8 realtime_controller_state

# predefined values to indicate our realtime_controller_state
int8 DISABLED = 0
int8 POSITION_SERVO = 3
int8 FORCE_SERVO = 4
int8 FIND_CONTACT = 5
int8 SLIP_SERVO = 6"""
  __slots__ = ['data']
  _slot_types = ['pr2_gripper_sensor_msgs/PR2GripperForceServoData']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       data

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(PR2GripperForceServoFeedback, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.data is None:
        self.data = pr2_gripper_sensor_msgs.msg.PR2GripperForceServoData()
    else:
      self.data = pr2_gripper_sensor_msgs.msg.PR2GripperForceServoData()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_2I3dBb().pack(_x.data.stamp.secs, _x.data.stamp.nsecs, _x.data.left_fingertip_pad_force, _x.data.right_fingertip_pad_force, _x.data.joint_effort, _x.data.force_achieved, _x.data.rtstate.realtime_controller_state))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.data is None:
        self.data = pr2_gripper_sensor_msgs.msg.PR2GripperForceServoData()
      end = 0
      _x = self
      start = end
      end += 34
      (_x.data.stamp.secs, _x.data.stamp.nsecs, _x.data.left_fingertip_pad_force, _x.data.right_fingertip_pad_force, _x.data.joint_effort, _x.data.force_achieved, _x.data.rtstate.realtime_controller_state,) = _get_struct_2I3dBb().unpack(str[start:end])
      self.data.force_achieved = bool(self.data.force_achieved)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_2I3dBb().pack(_x.data.stamp.secs, _x.data.stamp.nsecs, _x.data.left_fingertip_pad_force, _x.data.right_fingertip_pad_force, _x.data.joint_effort, _x.data.force_achieved, _x.data.rtstate.realtime_controller_state))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.data is None:
        self.data = pr2_gripper_sensor_msgs.msg.PR2GripperForceServoData()
      end = 0
      _x = self
      start = end
      end += 34
      (_x.data.stamp.secs, _x.data.stamp.nsecs, _x.data.left_fingertip_pad_force, _x.data.right_fingertip_pad_force, _x.data.joint_effort, _x.data.force_achieved, _x.data.rtstate.realtime_controller_state,) = _get_struct_2I3dBb().unpack(str[start:end])
      self.data.force_achieved = bool(self.data.force_achieved)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_2I3dBb = None
def _get_struct_2I3dBb():
    global _struct_2I3dBb
    if _struct_2I3dBb is None:
        _struct_2I3dBb = struct.Struct("<2I3dBb")
    return _struct_2I3dBb
